﻿/* Core scripts
(C) 2013, Virtual Technologies Ltd.
*/
var VTLib = new Object();
VTLib.CurrentLangIndex = 0;	// current language index
VTLib.isFORS = false;		// FORS is not supported defaultly
VTLib.DefaultPath = VTDefaultPath;
VTLib.ImgPath = VTImgPath;
VTLib.CommonPath = VTLib.DefaultPath + 'common/';
VTLib.CommonScriptPath = VTLib.CommonPath + 'bsscript/';
VTLib.CommonPluginPath = VTLib.CommonPath + 'editors/plugins/';
VTLib.EditorsPath = VTLib.CommonPath + 'editors/';
VTLib.CalendarFormat = "DD.MM.YYYY";
VTLib.ContainerSelector = "body";
VTLib.BigPhotoID = "VTLib_BPhoto";
VTLib.OverlayCounter = 0;
VTLib.Version = VTConfigVersion;

/**
 * Define environment and browser information.
 * From: CKSource - Frederico Knabben. All rights reserved.
 */
if ( !VTLib.env ) {
	VTLib.env = (function() {
		var agent = navigator.userAgent.toLowerCase();
		var opera = window.opera;
		var env = {
			ie: ( agent.indexOf( 'trident/' ) > -1 || agent.indexOf( 'msie ' ) > -1 ),
			opera: ( !!opera && opera.version ),
			webkit: ( agent.indexOf( ' applewebkit/' ) > -1 ),
			air: ( agent.indexOf( ' adobeair/' ) > -1 ),
			mac: ( agent.indexOf( 'macintosh' ) > -1 ),
			quirks: ( document.compatMode == 'BackCompat' ),
			mobile: ( agent.indexOf( 'mobile' ) > -1 ),
			iOS: /(ipad|iphone|ipod)/.test( agent )
		};
		env.gecko = ( navigator.product == 'Gecko' && !env.webkit && !env.opera && !env.ie );	// Firefox?
		if ( env.webkit ) {
			if ( agent.indexOf( 'chrome' ) > -1 )
				env.chrome = true;
			else
				env.safari = true;
		}
		var version = 0;
		if ( env.ie ) {
			if ( env.quirks || !document.documentMode )
				version = parseFloat( agent.match( /msie (\d+)/ )[ 1 ] );
			else
				version = document.documentMode;
		}
		if ( env.gecko ) {
			var geckoRelease = agent.match( /rv:([\d\.]+)/ );
			if ( geckoRelease ) {
				geckoRelease = geckoRelease[ 1 ].split( '.' );
				version = geckoRelease[ 0 ] * 10000 + ( geckoRelease[ 1 ] || 0 ) * 100 + ( geckoRelease[ 2 ] || 0 ) * 1;
			}
		}
		if ( env.opera )
			version = parseFloat( opera.version() );
		if ( env.air )
			version = parseFloat( agent.match( / adobeair\/(\d+)/ )[ 1 ] );
		if ( env.webkit )
			version = parseFloat( agent.match( / applewebkit\/(\d+)/ )[ 1 ] );
		env.version = version;
		env.isCompatible =
			// White list of mobile devices that CKEditor supports.
			env.iOS && version >= 534 ||
				!env.mobile && (
					( env.ie && version > 6 ) ||
						( env.gecko && version >= 10801 ) ||
						( env.opera && version >= 9.5 ) ||
						( env.air && version >= 1 ) ||
						( env.webkit && version >= 522 ) ||
						false
					);
		env.hidpi = window.devicePixelRatio >= 2;

		env.cssClass = 'vt_browser_' + ( env.ie ? 'ie' : env.gecko ? 'gecko' : env.opera ? 'opera' : env.webkit ? 'webkit' : 'unknown' );
		if ( env.quirks )
			env.cssClass += ' vt_browser_quirks';
		var slt = '', sgt = '';
		if ( env.ie ) {
			env.cssClass += ' vt_browser_ie' + ( env.quirks || env.version < 7 ? '6' : env.version );
			if ( env.quirks )
				env.cssClass += ' vt_browser_iequirks';
			if (env.quirks || env.version < 7) {
				slt = ' lt-ie7 lt-ie8 lt-ie9 lt-ie10 lt-ie11';
			} else if (env.version < 8) {
				slt = ' lt-ie8 lt-ie9 lt-ie10 lt-ie11';
				sgt = ' gt-ie6';
			} else if (env.version < 9) {
				slt = ' lt-ie9 lt-ie10 lt-ie11';
				sgt = ' gt-ie6 gt-ie7';
			} else if (env.version < 10) {
				slt = ' lt-ie10 lt-ie11';
				sgt = ' gt-ie6 gt-ie7 gt-ie8';
			} else if (env.version < 11) {
				slt = ' lt-ie11';
				sgt = ' gt-ie6 gt-ie7 gt-ie8 gt-ie9';
			} else {
				sgt = ' gt-ie6 gt-ie7 gt-ie8 gt-ie9 gt-ie10';
			}
		} else {
			sgt = ' gt-ie6 gt-ie7 gt-ie8 gt-ie9 gt-ie10';
		}
		env.cssClass += slt + sgt;
		if ( env.gecko ) {
			if ( version < 10900 )
				env.cssClass += ' vt_browser_gecko18';
			else if ( version <= 11000 )
				env.cssClass += ' vt_browser_gecko19';
			else
				env.cssClass += ' vt_browser_gecko';
		}
		if ( env.air )
			env.cssClass += ' vt_browser_air';
		if ( env.iOS )
			env.cssClass += ' vt_browser_ios';
		if ( env.hidpi )
			env.cssClass += ' vt_hidpi';
		env.cssClass += (env.ie? ' msie' : ' nomsie')
					+ (env.chrome? ' chrome' : ' nochrome')
					+ (env.opera? ' opera' : ' noopera')
					+ (env.gecko? ' gecko' : ' nogecko')
					+ (env.webkit? ' webkit' : ' nowebkit')
					;
		return env;
	})();
}

// container for popup-divs
VTLib.getDivContainer = function() { return $(VTLib.ContainerSelector); }

// choise message from array
VTLib.Lng = function(a)
{
	var i = VTLib.CurrentLangIndex;
	if (i >= a.length)
		i = a.length - 1;
	return a[i];
}
VTLib.loadedScripts = [];	// array of loaded scripts

// Ajax-загрузка скрипта
VTLib.usingScript = function (u, func, asyncMode) {
	var m = false;
	if (asyncMode)
		m = true;
	var key = u.toLowerCase();
	if (VTLib.loadedScripts[key])
		return;
	VTLib.loadedScripts[key] = true;
	$.ajax({ url: u + '?r=' + VTLib.Version, dataType: 'script', async: m, success: func, cache: true });
}

VTLib.loadedStyles = []; // array of loaded styles

// Загрузка стилевого файла
VTLib.usingStyle = function (u) {
	if (!u || u == '')
		return;
	var key = u.toLowerCase();
	if (VTLib.loadedStyles[key])
		return;
	VTLib.loadedStyles[key] = true;
	var head = document.getElementsByTagName('head')[0];
	var st = document.createElement('link');
	st.setAttribute('href', u + '?r=' + VTLib.Version);
	st.setAttribute('type', 'text/css');
	st.setAttribute('rel', 'STYLESHEET');
	head.appendChild(st);
}
// Инициализация выезжающей боковой панели
VTLib.sideSlideBarInit = function (divObj) {
    var minDX = 25;
	var opacity = 0.5;
	if ($('html').hasClass('lt-ie9')) {
		opacity = 1;
	}
    $(window).bind("scroll.vtlibPopup resize.vtlibPopup", function () {
        $(divObj).animate({
            left: VTLib.getWindowWidth() + $(document).scrollLeft() - divObj.width() - 2,
            top: VTLib.getWindowHeight() / 4 + $(document).scrollTop()
        }, { duration: 200, queue: false });
    });
    $(divObj).find(".scToolbarVTMenu").bind("click", function () {
        var w = divObj.attr("rel");
        var off = VTLib.getWindowWidth() + $(document).scrollLeft();
        if (divObj.width() < 60) {
            $(divObj).animate({ left: off - w, width: w, opacity: 1 }, { duration: 400, queue: false });
        } else {
            $(divObj).animate({ left: off - minDX, width: minDX, opacity: opacity }, { duration: 400, queue: false });
        }
    });
    $(divObj).find("a, button").bind("click", function () {
        var w = divObj.attr("rel");
        if (divObj.width() > 60) {
            var off = VTLib.getWindowWidth() + $(document).scrollLeft();
            $(divObj).fadeTo(100, opacity);
            $(divObj).animate({ left: off - minDX, width: minDX, opacity: opacity }, { duration: 500, queue: false });
        }
    });
    divObj.css("top", VTLib.getWindowHeight() / 4 + $(document).scrollTop());
    divObj.css("left", VTLib.getWindowWidth() - minDX + $(document).scrollLeft());
    divObj.css("z-index", 9999);
    divObj.width(minDX);
    divObj.css("position", "absolute");
    divObj.css("overflow", "hidden");
    $(divObj).find(".border").cssPNGFix();
    divObj.show();
    divObj.fadeTo(100, opacity);
}

// Predefine functions
function CalendarSubmitDate() {}
function CalendarToolsShow() {}
function CalendarSubmitDate() {}


function RS_set(targetElement, txt)
{
	var obj = document.getElementById(targetElement);
	if (obj)
		obj.innerHTML = txt;
}
function RS_call(url, frm, callBackFunc)
{
	var doc;
	var obj = document.getElementById("RS_iframe");
	if (obj.contentDocument)
	{	// NS6
		doc = obj.contentDocument; 
	}
	else if (obj.contentWindow)
	{	// IE5.5, IE6
		doc = obj.contentWindow.document;
	}
	else if (obj.document)
	{	// IE5
		doc = obj.document;
	}
	else
	{
		alert("Не поддерживаются фреймы!");
		return true;
	}
	if (frm && url && url != "")
		frm.action = url;
	doc.location.replace(url);
//	if (event)
//		event.cancelBubble = true;
	if (callBackFunc)
		$(doc.document).ready(callBackFunc);
	return false;
}
function setSelectorMessage(obj, txt)
{
	if (!obj)
		return;
	if (obj.selectedIndex)
	{
		obj.selectedIndex = 0;
		while(obj.length > 1)
			obj.remove(1);
		var opt = obj.options[0];
		opt.text = txt;
		opt.value = "";
		opt.style.color = "red";
		opt.style.backgroundColor = "yellow";
	}
	else
	{
		obj.value = "";
	}
}

//Преобразование символов в JSON-безопасные
function JSONEncode(txt)
{
	if (txt)
		return '' + txt
		.replace(/\&/g, "&amp;")
		.replace(/\\/g, "&_backslash;")
		.replace(/'/g, "&apos;")
		.replace(/"/g, "&quot;")
		.replace(/\r/g, "&_curr;")
		.replace(/\n/g, "&_curn;")
		.replace(/</g, "&lt;")
		.replace(/>/g, "&gt;")
		.replace(/,/g, "&_coma;")
		.replace(/\t/g, "&_tab;")
		.replace(/\b/g, "&_back;")
		;
	return "";
}
VTLib.JSONEncode = JSONEncode;
//Обратное преобразование символов из JSON-безопасных
function JSONDecode(txt)
{
	if (txt)
		return '' + txt
		.replace(/\&_back;/g, "\b")
		.replace(/\&_tab;/g, "\t")
		.replace(/\&_coma;/g, ",")
		.replace(/\&gt;/g, ">")
		.replace(/\&lt;/g, "<")
		.replace(/\&_curn;/g, "\n")
		.replace(/\&_curr;/g, "\r")
		.replace(/\&quot;/g, '"')
		.replace(/\&apos;/g, "'")
		.replace(/\&_backslash;/g, "\\")
		.replace(/\&amp;/g, "&")
		;
	return "";
}
VTLib.JSONDecode = JSONDecode;

//Преобразование символов в тего-безопасные
function metaEncode(txt)
{
	if (txt)
		return '' + txt
			.replace(/&/g, "&amp;")
			.replace(/\\/g, "&_backslash;")
			.replace(/'/g, "&apos;")
			.replace(/"/g, "&quot;")
			.replace(/</g, "&lt;")
			.replace(/>/g, "&gt;")
			;
	return "";
}
VTLib.metaEncode = metaEncode;
//Обратное преобразование символов из JSON-безопасных
function metaDecode(txt)
{
	if (txt)
		return '' + txt
			.replace(/&gt;/g, ">")
			.replace(/&lt;/g, "<")
			.replace(/&quot;/g, '"')
			.replace(/&apos;/g, "'")
			.replace(/&_backslash;/g, "\\")
			.replace(/&amp;/g, "&")
			;
	return "";
}
VTLib.metaDecode = metaDecode;

// преобразовать JSON-строку или содержимое DOM-объекта в нативный JS-объект.
VTLib.html2json = function (txt) {
	if (typeof txt != 'string') {
		var s = $(txt).text();
		if (s == undefined) {
		    alert('Не найден DOM-объект с идентификатором ' + txt);
		    return null;
		}
		txt = s;
	}
	if (txt == '')
	    return {};
    try {
//        return $.evalJSON('(' + txt + ')');
        return eval('(' + txt + ')');
    }
    catch (e) {
	    alert('Ошибка разбора JSON-данных:\r\n' + $.toJSON(e) + '\r\nСтрока:\r\n' + txt); 
        return null; 
    }
}

VTLib.array2dictionary = function (sourceArray, keyField) {
    for (var i = 0; i < sourceArray.length; i++) {
        r = sourceArray[i];
        var key = 'k_' + r[keyField];
        sourceArray[key] = r;
    }
    sourceArray.hasValue = function (key) {
        if (!key || !sourceArray['k_' + key]) {
            return false;
        }
        return true;
    }
    sourceArray.getValue = function (key) {
        var value = sourceArray['k_' + key]
        if (value == undefined) {
            return undefined;
        }
        return value;
    };
    return sourceArray; 		// вернуть старый массив с новыми свойствами именованных объектов (значение объекта - исходная запись)
}

VTLib.dictionary2array = function (dictionary) {
    var arrayDictionary = new Array();
    var index = 0;
    for (var key in dictionary) {
        // Индексируемые объекты
        arrayDictionary[index] = {
            'key': key
            , 'value': dictionary[key]
        };

        // Прямое обращение по ключу
        arrayDictionary['k_' + key] = dictionary[key];

        index++;
    }
    arrayDictionary.hasValue = function (key) {
        if (!key || !arrayDictionary['k_' + key]) {
            return false;
        }
        return true;
    }
    // Функция получения значения справочника по ключу без префикса
    arrayDictionary.getValue = function (key) {
        var value = arrayDictionary['k_' + key];
        if (value == undefined) {
            return 'значение отсутствует в справочнике';
        }
        return value;
    };
    return arrayDictionary;
}

function wsOpenCard(url, w, h) {
    if (window.event) {
		window.event.cancelBubble=true;
	}
	var winName = "_blank";
	var winPar = "menubar=no,resizable=yes,status=yes,titlebar=yes,toolbar=no,scrollbars=yes";
	w = w || 1100;
	h = h || 800;
	if (w)
	{
		var openWidth = w;
		var openLeft = Math.max(0, (screen.width - openWidth) / 2);
		winPar += ",width=" + openWidth + ",left=" + openLeft;
	}
	if (h)
	{
		var openHeight = h;
		var openTop = Math.max(0, (screen.height - openHeight) / 3);
		winPar += ",height=" + openHeight + ",top=" + openTop;
	}
	window.open(url, winName, winPar);
	return false;
}
function wsNavigate(url) {
	if (window.event) {
		window.event.cancelBubble=true;
	}
	document.location.href = url;
	return false;
}

function wsSetWindowSize(w, h)
{
	window.moveTo(Math.max(0, screen.width / 2 - w / 2), Math.max(0, screen.height / 2 - h / 2));
	window.resizeTo(w, h);
}

function wsCloseCard(reloadParent)
{
	if (reloadParent)
	{
		if (window.opener != null)
		{
			if (!window.opener.closed)
			{
				window.opener.location.reload();
				window.opener.focus();
			}
		}
	}
	window.close();
}

// Common site scripts
function deleteRecord(url, txt)
{
	if (window.event)
		window.event.cancelBubble = true;
	if (txt == null)
		txt = "";
	if (confirm("Удалить запись?\r\n" + txt))
		wsOpenCard(url);
}
// Delete record in inline-mode
function deleteRecordInline(url, txt) {
	if (window.event)
    	window.event.cancelBubble = true;
    if (txt == null)
        txt = "Удалить?";
    if (confirm(txt)) {
        window.open(url + "&CallMode=inline", "RS_iframe");
    }
    return false;
}
function reverseSortDir(frm)
{
	var s = "Up";
	if (frm.SortDir.value == "Up")
		s = "Down";
	frm.SortDir.value = s;
	document.all.SortImg.src="../img/sort" + s + ".gif";
}
function clearDateFields(frm, fld1, fld2, fld3, fld4, fld5, fld6, fld7, fld8)
{
	if (fld1) { frm[fld1].value = ""; frm[fld1 + "_"].value = ""; }
	if (fld2) { frm[fld2].value = ""; frm[fld2 + "_"].value = ""; }
	if (fld3) { frm[fld3].value = ""; frm[fld3 + "_"].value = ""; }
	if (fld4) { frm[fld4].value = ""; frm[fld4 + "_"].value = ""; }
	if (fld5) { frm[fld5].value = ""; frm[fld5 + "_"].value = ""; }
	if (fld6) { frm[fld6].value = ""; frm[fld6 + "_"].value = ""; }
	if (fld7) { frm[fld7].value = ""; frm[fld7 + "_"].value = ""; }
	if (fld8) { frm[fld8].value = ""; frm[fld8 + "_"].value = ""; }
}
function submitDateFields(frm, fld1, fld2, fld3, fld4, fld5, fld6, fld7, fld8)
{
	if (fld1) { submitDate(frm, fld1); }
	if (fld2) { submitDate(frm, fld2); }
	if (fld3) { submitDate(frm, fld3); }
	if (fld4) { submitDate(frm, fld4); }
	if (fld5) { submitDate(frm, fld5); }
	if (fld6) { submitDate(frm, fld6); }
	if (fld7) { submitDate(frm, fld7); }
	if (fld8) { submitDate(frm, fld8); }
}

function getDocumentStylesList(defPath)
{
	var stList = "", dlm = "";
	if (!document.styleSheets)
	{
		stList = defPath + "st/base.css," + defPath + "st/st.csss";
	}
	else
	{
		var st = document.styleSheets;
		var i;
		for (i = 0; i < st.length; i++) {
			var sStyle = st[i];
			if (sStyle.href)
			{
				if (sStyle.href != ""
					&& sStyle.href.indexOf("ws4.css") < 0
					&& sStyle.href.indexOf("editor_") < 0
					&& sStyle.href.indexOf("contextmenu.css") < 0
					)
				{
					stList += dlm + sStyle.href;
					dlm = ",";
				}
			}
		}
	}
	return stList;
}

// Find and check requered fields
VTLib.getRequeredFieldsEmpty = function(frmId)
{
	VTLib.errMsg = "";
	var requiredItems = 
		$("#" + frmId + " .requred")		
		.add($("#" + frmId + " .RequiredValue"));
	requiredItems.each(function(){
		if ($(this).val() == "")
			VTLib.errMsg += "- " + $(this).attr("friendly") + "\r\n";
	});
	return VTLib.errMsg;
}

// Find and check requered fields for feedback forms
VTLib.feedbackCheckFields = function(frmId, jsonPar)
{
	var frm = document.getElementById(frmId);
	if (!frm)
		return true;
	var aFld = jsonPar.Fields;
	var err = "";
	var i;
	$(frm).find(".frmRequered").removeClass("frmRequered");
	for(i=0; i < aFld.length; i++)
	{
		var fld = aFld[i];
		if (fld.FieldRequered)
		{
			var val = $(frm).find("[name=" + fld.FieldName + "]").val();
			if (val == "")
			{
				err += "- " + ((fld.FieldLabel)? fld.FieldLabel : fld.FieldName) + "\r\n";
				var fldID = frmId + "_" + fld.FieldName;
				$(frm).find("#" + fldID).addClass("frmRequered");
			}
		}
	}
	if (err == "")
		return true;
	window.alert(VTLib.Lng(["Необходимо заполнить все обязательные поля!\r\n", "Type all requered filds!\r\n"]) + err);
	return false;
}

// Selector of Languages parts of edit card
VTLib.LangsArray = new Array();
VTLib.selectLang = function(formId, lng)
{
	$("#" + formId + " .wsLangSel").addClass("wsLang");
	$("#" + formId + " .wsLangSel").removeClass("wsLangActive");
	$("#" + lng + "RowSel").removeClass("wsLang");
	$("#" + lng + "RowSel").addClass("wsLangActive");
	$("#" + formId + " .wsLangTab").css("display", "none");
	$("#" + lng + "Row").css("display", "");
}

// чтение параметров
function VTReadPar(par)
{
	if (par == null)
		par = new Object();
	var a = document.location.search.substr(1).split('&');
	var parItem;
	var i;
	for (i = 0 ; i < a.length ; i++)
	{
		parItem = a[i].split('=') ;
		par[parItem[0]] = unescape(parItem[1]);
	}
	if (par.basePath == null)
	{
		var baseUrl = parent.document.location;
		par.basePath = baseUrl.protocol + "//" + baseUrl.host + "/common/";
	}
	return par;
}

function VTCloseDialog(val)
{
	window.returnValue = (val == null)? "" : val;
	window.close();
}

function VTShowDialog(pagePath, width, height, attr)
{
	var params = "";
	if (width != null)		params += "dialogWidth:" + width + "px;";
	if (height != null)		params += "dialogHeight:" + height + "px;";
	if (attr == null)
		params += "help:no;scroll:no;status:no;";
	else
		params += attr;
	return showModalDialog(pagePath, window, params);
}

function padi(v, n)
{
	var s = "" + v;
	while (s.length < n)
		s = "0" + s;
	return s;
}

VTLib.atof = function(v) {
	if (typeof(v) == 'string') {
		v = v.replace(" ", "").replace('&nbsp;', '').replace(",", ".");
	}
	v =parseFloat(v);
	return isNaN(v)? 0.00 : v;
}


////// JQuery plugins ///////

// Based on: "$Id: jquery_csspngfix.src.js,v 1.0 2008/06/14 18:29:32 skilip Exp $"
// Updated and corrected by SSJ, 2010-09-03
$(function () {
	/*
    var matched, browser;
    var uaMatch = function (ua) {
        ua = ua.toLowerCase();
        var match = /(chrome)[ \/]([\w.]+)/.exec(ua) ||
            /(webkit)[ \/]([\w.]+)/.exec(ua) ||
            /(opera)(?:.*version|)[ \/]([\w.]+)/.exec(ua) ||
            /(msie) ([\w.]+)/.exec(ua) ||
            ua.indexOf("compatible") < 0 && /(mozilla)(?:.*? rv:([\w.]+)|)/.exec(ua) ||
            [];
        return {
            browser: match[1] || "",
            version: match[2] || "0"
        };
    };
    matched = uaMatch(navigator.userAgent);
    browser = {};
    if (matched.browser) {
        browser[matched.browser] = true;
        browser.version = matched.version;
    }
    // Chrome is Webkit, but Webkit is also Safari.
    if (browser.chrome) {
        browser.webkit = true;
    } else if (browser.webkit) {
        browser.safari = true;
    }
    $.browser = browser;
	*/
	var env = VTLib.env;
	$.browser = {
		msie:env.ie,
		chrome:env.chrome,
		webkit:env.webkit,
		opera:env.opera,
		safari:env.safari,
		version:env.version
	};
	$('html').addClass(VTLib.env.cssClass);

    jQuery.fn.cssPNGFix = function () { return $(this); }
	jQuery.fn.imgPNGFix = function () { return $(this); }
	jQuery.fn.PNGFix = function () { return $(this); }
	if (!VTLib.env.ie)
		return; 	// для всех браузеров, кроме MSIE, ничего делать не нужно.
	if (VTLib.env.version >=7)
		return;
	// для 6-й версии MSIE
	jQuery.fn.imgPNGFix = function (sizingMethod) {
		var sizingMethod = (sizingMethod) || 'scale';
		$(this).each(function () {
			var el = $(this);
			var a = el.attr('vt_pngfixed');
			if (a && a == '1')
				return;
			el.attr('vt_pngfixed', '1');
			var spacer_src = VTLib.CommonPath + '/img/p.gif';
			var src = el.attr('src');
			el.attr('src', spacer_src);
			el.css({ 'background': 'none', 'filter': 'progid:DXImageTransform.Microsoft.AlphaImageLoader(src="' + src + '", sizingMethod="' + sizingMethod + '")' });
		});
		return $(this);
	};
	jQuery.fn.cssPNGFix = function () {
		$(this).each(function () {
			var el = $(this);
			var a = el.attr('vt_pngfixed');
			if (a && a == '1')
				return;
			el.attr('vt_pngfixed', '1');
			var sizingMethod = (el.css('backgroundRepeat') == 'no-repeat') ? 'crop' : 'scale';
			var css_bg_img = el.css('background-image');
			var bg_img = css_bg_img.substring(5, css_bg_img.length - 2);
			el.css({ 'background': 'none', 'filter': 'progid:DXImageTransform.Microsoft.AlphaImageLoader(src="' + bg_img + '", sizingMethod="' + sizingMethod + '")' });
		});
		return $(this);
	};
	jQuery.fn.PNGFix = function () {
		$(this).each(function () {
			return (this.tagName.toUpperCase() == 'IMG') ? $(this).imgPNGFix('image') : $(this).cssPNGFix();
		});
	};
	$('.imgPNG').PNGFix();
});

VTLib.fixPNG = function (a) { return $(a).PNGFix(); }

VTLib.spoilerClick = function (obj) {
	//find container
	var p = $(obj).parent();
	while (p && !p.hasClass('scSpoiler')) {
		p = $(p).parent();
	}
	if (!p)
		return false;
	var d = $(p).find('.SpoilerDiv');
	if ($(d).is(':hidden')) {
		$(p).find('.SpoilerOpen').hide();
		$(p).find('.SpoilerClose').show();
		d.slideDown(1000);
	} else {
		$(p).find('.SpoilerClose').hide();
		$(p).find('.SpoilerOpen').show();
		d.slideUp(600);
	}
	return false;
}

//japan date string to c-date string
function s2c(sData) {
	if (sData == null || sData.length == 0)
		return "";
	if (sData.length == 10)
		return sData;
	return sData.substring(6, 8) + "." + sData.substring(4, 6) + "." + sData.substring(0, 4);
}

function datetime2s(dDate) {
	if (dDate == null || isNaN(dDate)) return "";
	var vDD		= new String(dDate.getDate());
	var vMM		= new String(dDate.getMonth() + 1);
	if (vDD.length < 2) vDD = "0" + vDD;
	if (vMM.length < 2) vMM = "0" + vMM;
	var vYYYY	= new String(dDate.getFullYear());
	var vHH		= new String(dDate.getHours());
	var vMi		= new String(dDate.getMinutes());
	var vSS		= new String(dDate.getSeconds());
	var vMS		= new String(dDate.getMilliseconds());
	var time = "";
	if (!(vHH == vMi == vSS == vMS)) {
		if (vHH.length < 2) vHH = "0" + vHH;
		if (vMi.length < 2) vMi = "0" + vMi;
		if (vSS.length < 2) vSS = "0" + vSS;
		if (vMS.length < 2) vMS = "0" + vMS;
		if (vMS.length < 3) vMS = "0" + vMS;
		time = " " + vHH + ":" + vMi + ":" + vSS + "." + vMS;
	}
	return vYYYY + vMM + vDD + time;
}

function c2date(s, outputFormat) {
	if (s == null || s.length == 0)
		return null;
	var fmt = outputFormat || VTLib.CalendarFormat;
	s = s.trim()
		.replace(/,/g, '.')
		.replace(/\//g, '.')
		.replace(/-/g, '.')
		.replace(/  /g, ' ')
		.replace(/ /g, '.')
	;
	var d = new Date();
	var y = d.getFullYear(), m = d.getMonth(), d = d.getDate(),
		hh = 0, mm = 0,
		i = s.indexOf('.');
	if (i > 0)
	{
		d = parseInt(s.substring(0, i), 10);
		s = s.substring(i + 1);
		i = s.indexOf('.');
		if (i > 0)
		{
			m = parseInt(s.substring(0, i), 10) - 1;
			s = s.substring(i + 1);
			y = parseInt(s, 10);
			if (y < 30)
				y += 2000;
		} else {
			m = parseInt(s, 10) - 1;
		}
		if (fmt.substring(0, 5) == "MM.DD")
		{
			var tmp = d - 1;
			d = m + 1;
			m = tmp;
		}
	} else {
		d = parseInt(s, 10);
	}
	i = s.indexOf(' ');
	if (i > 0)
	{
		s = s.substring(i + 1);
		hh = parseInt(s, 10);
		i = s.indexOf(':');
		if (i > 0) {
			s = s.substring(i + 1);
			mm = parseInt(s, 10);
		}
	}
	return new Date(y, m, d, hh, mm);
}

// Названия месяцев и дней недели
gMonthsNames = ["Январь", "Февраль", "Март", "Апрель", "Май", "Июнь","Июль", "Август", "Сентябрь", "Октябрь", "Ноябрь", "Декабрь", "Ошибка"];
gMonthsNamesEn = ["January", "February", "March", "April", "May", "June","July", "August", "September", "October", "November", "December", "Error"];
function getMonthName(monthNo)
{
	if (VTLib.CurrentLangID == "En")
		return gMonthsNamesEn[Math.min(12, monthNo)];
	return gMonthsNames[Math.min(12, monthNo)];
}
gWeekDaysNames = ["Вс", "Пн", "Вт", "Ср", "Чт", "Пт", "Сб"];
gWeekDaysNamesEn = ["Su", "Mo", "Tu", "Wd", "Th", "Fr", "Sa"];
function getWeekDayName(dayNo)
{
	if (VTLib.CurrentLangID == "En"){
		return gWeekDaysNamesEn[dayNo % 7];
	}
	return gWeekDaysNames[dayNo % 7];
}


function date2c(dDate, outputFormat) {
	var fmt = outputFormat || VTLib.CalendarFormat;
	if (dDate == null || isNaN(dDate)) return "";
	var vDD = new String(dDate.getDate());
	if (vDD.length < 2) 		vDD = "0" + vDD;
	var vMM = new String(dDate.getMonth()+1);
	if (vMM.length < 2) 		vMM = "0" + vMM;
	var vMONTH = this.getMonthName(dDate.getMonth());
	var vMON = vMONTH.substr(0,3).toUpperCase();
	var vYYYY = new String(dDate.getFullYear());
	var vYY = vYYYY.substr(2,2);

	switch (fmt)
	{
		case "YYYYMMDD": 		return vYYYY + vMM + vDD;

		case "DD.MM.YYYY": 		return vDD + "." + vMM + "." + vYYYY;
		case "DD/MM/YYYY":		return vDD + "/" + vMM + "/" + vYYYY;
		case "DD/MM/YY":		return vDD + "/" + vMM + "/" + vYY;
		case "DD-MM-YYYY": 		return vDD + "-" + vMM + "-" + vYYYY;
		case "DD-MM-YY": 		return vDD + "-" + vMM + "-" + vYY;

		case "MM.DD.YYYY": 		return vMM + "." + vDD + "." + vYYYY;
		case "MM/DD/YYYY":		return vMM + "/" + vDD + "/" + vYYYY;
		case "MM/DD/YY":		return vMM + "/" + vDD + "/" + vYY;
		case "MM-DD-YYYY": 		return vMM + "-" + vDD + "-" + vYYYY;
		case "MM-DD-YY": 		return vMM + "-" + vDD + "-" + vYY;

		case "DD MON YYYY": 	return vDD + " " + vMON + " " + vYYYY;
		case "DD/MON/YYYY": 	return vDD + "/" + vMON + "/" + vYYYY;
		case "DD/MON/YY":	 	return vDD + "/" + vMON + "/" + vYY;
		case "DD-MON-YYYY": 	return vDD + "-" + vMON + "-" + vYYYY;
		case "DD-MON-YY": 		return vDD + "-" + vMON + "-" + vYY;

		case "DD MONTH YYYY": 	return vDD + " " + vMONTH + " " + vYYYY;
	}
	return vDD + " " + vMON + " " + vYYYY;
}
function datetime2c(d, outputFormat) {
	if (typeof (d) != 'Date') {
		try { d = new Date(d); }
		catch (ex) { return ''; }
	}
	return date2c(d) + ' ' + d.getHours() + ':' + d.getMinutes();
}
function date2s(dDate) {
	if (dDate == null) return "";
	if (isNaN(dDate)) return "";
	var vDD = new String(dDate.getDate());
	if (vDD.length < 2) 		vDD = "0" + vDD;
	var vMM = new String(dDate.getMonth()+1);
	if (vMM.length < 2) 		vMM = "0" + vMM;
	var vYYYY = new String(dDate.getFullYear());
	return vYYYY + vMM + vDD;
}


function trimL(str) {
	return str.replace(/^\s+/, '');
}
function trimR(str) {
	return str.replace(/\s+$/, '');
}
function trim(str) {
	return trimR(trimL(str));
}
function trimSpaces(str) {
	return str.replace(/\s{2,}/g, ' ');
}

function num2str(n, isRound) {
    if (typeof(n) == 'string')
        n = atof(n);
    if (isRound)
        n = Math.round(n);
    else if (n.toFixed)
        n = n.toFixed(2);
    return n.toString().replace(/(\d)(?=(\d\d\d)+([^\d]|$))/g, '$1&nbsp;');
}
function int2str(n) {
	var s = '';
	if (_.isString(n))
		n = parseInt(n.replace(/\s/g, ''), 10);
	if (_.isNumber(n)) {
		var src = Math.round(n).toString();
		var d = -1;
		for(var i = src.length-1; i >= 0; i--) {
			if (d++ == 2) {
				s = ' ' + s;
				d = 0;
			}
			s = src.charAt(i) + s;
		}
	}
	return s;
}

function atof(s) {
	var v = parseFloat(s);
	if (_.isNaN(v))
		return 0;
	return v;
}
function atoi(s) {
	var v = parseInt(s, 10);
	if (_.isNaN(v))
		return 0;
	return v;
}

$(document).ready(function () {
	VTLib.usingScript(VTLib.CommonScriptPath + 'calendartools.js', null, true);
	VTLib.usingScript(VTLib.CommonScriptPath + 'popup.js', null, true);
    VTLib.usingScript(VTLib.CommonScriptPath + 'infoblock.js', null, true);
    VTLib.usingScript(VTLib.CommonScriptPath + 'photoslideradv.js', null, true);
    VTLib.usingScript(VTLib.CommonScriptPath + 'photogallery.js', null, true);

    /**
    * Geometry.js: portable functions for querying window and document geometry
    *
    * This module defines functions for querying window and document geometry.
    *
    * getWindowX/Y( ): return the position of the window on the screen
    * getViewportWidth/Height( ): return the size of the browser viewport area 
    * getDocumentWidth/Height( ): return the size of the document
    * getHorizontalScroll( ): return the position of the horizontal scrollbar
    * getVerticalScroll( ): return the position of the vertical scrollbar
    *
    * Note that there is no portable way to query the overall size of the
    * browser window, so there are no getWindowWidth/Height( ) functions.
    *
    * IMPORTANT: This module must be included in the <body> of a document 
    *            instead of the <head> of the document.
    */
    var widthScrollX = 17;
    if (window.screenLeft) { // IE and others
        VTLib.getWindowX = function () { return window.screenLeft; };
        VTLib.getWindowY = function () { return window.screenTop; };
    }
    else if (window.screenX) { // Firefox and others
        VTLib.getWindowX = function () { return window.screenX; };
        VTLib.getWindowY = function () { return window.screenY; };
    }

    if (window.innerWidth) { // All browsers but IE
        VTLib.getWindowWidth = function () { return window.innerWidth - widthScrollX; };
        VTLib.getWindowHeight = function () { return window.innerHeight; };
        VTLib.getHorizontalScroll = function () { return window.pageXOffset; };
        VTLib.getVerticalScroll = function () { return window.pageYOffset; };
    }
    else if (document.documentElement && document.documentElement.clientWidth) {
        // These functions are for IE 6 when there is a DOCTYPE
        VTLib.getWindowWidth =
            function () { return document.documentElement.clientWidth; };
        VTLib.getWindowHeight =
            function () { return document.documentElement.clientHeight; };
        VTLib.getHorizontalScroll =
            function () { return document.documentElement.scrollLeft; };
        VTLib.getVerticalScroll =
            function () { return document.documentElement.scrollTop; };
    }
    else if (document.body.clientWidth) {
        // These are for IE4, IE5, and IE6 without a DOCTYPE
        VTLib.getWindowWidth =
            function () { return document.body.clientWidth; };
        VTLib.getWindowHeight =
            function () { return document.body.clientHeight; };
        VTLib.getHorizontalScroll =
            function () { return document.body.scrollLeft; };
        VTLib.getVerticalScroll =
            function () { return document.body.scrollTop; };
    }

    // These functions return the size of the document. They are not window
    // related, but they are useful to have here anyway.
    /*
    if (document.documentElement && document.documentElemnet.scrollWidth) {
        VTLib.getDocumentWidth =
            function () { return document.documentElement.scrollWidth; };
        VTLib.getDocumentHeight =
            function () { return document.documentElement.scrollHeight; };
    }
    else if (document.body.scrollWidth) {
        VTLib.getDocumentWidth =
            function () { return document.body.scrollWidth; };
        VTLib.getDocumentHeight =
            function () { return document.body.scrollHeight; };
    }
    */
});

// debug messaging
VTLib.debugOn = false;
VTLib.debug = function debug(o) {
	if (!VTLib.debugOn)
		return;
	if (typeof o == 'string')
		alert('Строка: ' + o);
	else
		alert('Объект: ' + $.toJSON(o));
}

// consol log messaging
VTLib.vtlogOn = false;
function vtlog() {
	if (!VTLib.vtlogOn)
		return;
	_.each(arguments, function(a) { console.log(a);});
}

// AJAX-request
VTLib.ajaxJSON = function (url, par, callback, errorback) {
    VTLib.debug($.toJSON('Запрос к серверу: ' + url + ' Параметры: ' + $.toJSON(par)));
    $.ajax({
        url: url,
        type: 'POST',
        dataType: 'json',
        data: par,
        success: function (result) {
            VTLib.debug('Ответ сервера: ' + $.toJSON(result));
            callback(result);
        },
        error: errorback || function (e, v) {
            var msg = 'Ошибка при обращении к серверу и получении результата:\r\n' + v;
            console.log(msg, e);
            if (errorback)
                errorback(e, msg);
            else
                alert(msg);
        }
    });
}


VTLib.cookies = {
	parseCookies: function () {
		var cookies = {};
		var separated = document.cookie.split(';');
		for (var i = 0; i < separated.length; i++) {
			var pair = separated[i].split('=');
			var name = pair[0].replace(/^\s*/, '').replace(/\s*$/, '');
			try {
				cookies[name] = $.evalJSON(decodeURIComponent(pair[1]));
			} catch (ex) { }

		}
		return cookies;
	},
	get: function (cookieName) {
		var cookies = VTLib.cookies.parseCookies();
//		alert(document.cookie);
		return (typeof cookies[cookieName] !== 'undefined') ? cookies[cookieName] : null;
	},
	set: function (name, value, days) {
		var expires = '';
		if (days) {
			var date = new Date();
			date.setTime(date.getTime() + (days * 24 * 60 * 60 * 1000));
			var expires = '; expires=' + date.toGMTString();
		}
		value = $.toJSON(value);
		document.cookie = name + '=' + encodeURIComponent(value) + expires + '; path=/';
//		alert(document.cookie);
	},
	del: function (cookieName) {
		VTLib.cookies.set(cookieName, null, -1);
	}
};

// Compile template
VTLib.template = function(tmplID) {
	if (tmplID)
		return _.template(tmplID);
	return _.template('');
};
// Clean forms values where input elements contain attrubute "data-cleaner='_cleane_value_'"
VTLib.formCleaner = function(btn) {
    var $frm = $(btn).closest('form');
    $frm.find('[data-cleaner]').each(function() {
        if ($(this).prop('type') == 'checkbox') {
            this.checked = false;
        } else {
            $(this).val($(this).data('cleaner'));
        }
    });
    $frm.find('.FieldDate input').val('');
}


VTLib.editorInit = function(el, cfg) {
	CKEDITOR_BASEPATH = VTLib.EditorsPath + 'CKE43/';
	VTLib.usingScript(CKEDITOR_BASEPATH + 'ckeditor.js');
	VTLib.usingScript(CKEDITOR_BASEPATH + 'adapters/jquery.js');
	var ts = VTLib.Version;	// версия конфигурации
//	ts = ( new Date() ).valueOf();		// отмена кэширования
	CKEDITOR.timestamp = ts;		// версия редактора
	var height = $(el).parent().height();
	cfg.customConfig = CKEDITOR_BASEPATH +  'vtconfig.js?r='+ts;
	cfg.RE_parentHeight = height;
	cfg.height = cfg.resize_minHeight = cfg.resize_maxHeight = cfg.RE_parentHeight;
	cfg.autoGrow_maxHeight = cfg.autoGrow_minHeight = cfg.height;
//	var edt = CKEDITOR.replace($(el).get(0), cfg);
//	edt.resize('100%', height, false);
//	return edt;
	var edt = $(el).ckeditor(function() {
//		this.resize('100%', height, false);
	}, cfg).editor;
	return edt;
}
